unit lfen_com_1;
interface
uses
  ComObj,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_Init: TEdit;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Edit_1C8_Name: TEdit;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    ListBox1: TListBox;
    Label_YesConnect: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    s1C8_ole : Variant; //  1Cv8

  end;

var
  Form1: TForm1;


//  1Cv8 (COM)
function ConnectTo1C8_COM(s1cAppProgID,InitLine : string) : Variant;
//,    (HandleAny)
function YesLinkToVariant(HandleAny : Variant) : boolean;


implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  //
  s1C8_ole:=UnAssigned;
  Edit_1C8_Name.Text:='V8.COMConnector';
  //Edit_Init.Text:='File=F:\1Cv8.DB\HomeLib';
  Edit_Init.Text:='File=C:\SP\1Cv8.DB\HomeLib';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  s1C8_ole:=UnAssigned;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  s1C8_ole:=UnAssigned;
  Label_YesConnect.Visible:=false;
  ListBox1.Items.Clear;
  //  1Cv8
  s1C8_ole:=ConnectTo1C8_COM(Trim(Edit_1C8_Name.Text),Trim(Edit_Init.Text));
  if YesLinkToVariant(s1C8_ole) then begin
     Label_YesConnect.Visible:=true;
  end
  else begin
     ShowMessage('');
  end;
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
//    
Var
  TN_name : string;  //  
  TN_ole  : variant; //c   : .
  TN_meta_ole  : variant; //c   ,   
  i_Val,    // ()  
  Count_Val : integer;//-   
begin
  ListBox1.Items.Clear;

  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin

     //    : .
     TN_ole := s1C8_ole..;
     // -    
     Count_Val:=TN_ole.()*1;
     //ShowMessage(IntToStr(Count_Val));
     if Count_Val>0 then begin
        //       
        for i_Val:=0 to (Count_Val-1) do
         begin
           //    ,   
           TN_meta_ole := s1C8_ole...;
           //   
           TN_name:=Trim(TN_meta_ole..(i_Val).);
           //   ListBox1
           ListBox1.Items.Add(TN_name);
        end;
     end;

  end
  else begin
     ShowMessage('     1Cv8 !');
  end;
end;


function ConnectTo1C8_COM(s1cAppProgID,InitLine : string) : Variant;
//  1Cv8 (COM)
{
//s1cAppProgID -  . COM-  1Cv8 (  )
   V8.COMConnector
InitLine ( ) :
    .. :
    File=\Trade
    Usr=
    Pwd=
  -  .. :
    Srvr=Server1C ( ,     1)
    Ref=Trade (      1)
    Usr=
    Pwd=
}
//  :   . COM-  1Cv8
//                          Unassigned (  )
begin
  Result:=Unassigned;
  s1cAppProgID:=Trim(s1cAppProgID);
  if Length(s1cAppProgID)<=0 then s1cAppProgID:='V8.COMConnector';
  InitLine:=Trim(InitLine);
  if Length(s1cAppProgID)>0 then begin
     // 
     Result := CreateOleObject(s1cAppProgID);
     //  
     if YesLinkToVariant(Result) then begin
        //  1Cv8     COM-
        Result:=Result.Connect(InitLine);
        if not YesLinkToVariant(Result) then Result:=Unassigned;
     end;
  end;
end;



function YesLinkToVariant(HandleAny : Variant) : boolean;
//,    (HandleAny)
begin
 Result:=FALSE;
 if not VarIsEmpty(HandleAny) then Result:=TRUE;
end;



end.



